Version = "1.21"
orb = module.internal('orb')
ts = module.internal('TS')
pred = module.internal('pred')
damage = module.internal('damage')

mymenu = menu("Jonathan's Graves", "J's Graves")
mymenu:header("name","Jonathan's Graves!")
mymenu:menu("draw_settings", "Draw Settings")
mymenu.draw_settings:boolean("qRange", "Draw Q range", true)
mymenu.draw_settings:boolean("wRange", "Draw W range", true)
mymenu.draw_settings:boolean("eRange", "Draw E range", true)
mymenu.draw_settings:boolean("rRange", "Draw R range", true)
mymenu:menu("setKS", "Kill Steal Settings")
mymenu.setKS:boolean("qSteal", "Use [Q] to killsteal", true)
mymenu.setKS:boolean("rSteal", "Use [R] to killsteal", true)
mymenu:menu("q", "Q Settings")
mymenu.q:header("qs", "Q Settings")
mymenu.q:boolean("qc", "Use [Q] in combo", true)
mymenu.q:boolean("qh", "Use [Q] in harass", true)
mymenu.q:slider("harassQmana", "If mana% >= X% [Q] enemy", 30, 0, 100, 1)
mymenu.q:boolean("qlc", "Use [Q] in laneclear", true)
mymenu.q:slider("lcQmana", "If mana% >= X% use [Q] on creeps", 30, 0, 100, 1)
mymenu.q:slider("minCountQ", "Cast [Q] if creep count >= X. (will still cast with tanky minions)", 3, 1, 5, 1)
mymenu.q:slider("setQrange", "Set distance when Q fires in combo mode. Max range is 925. Press F6 to after set", 875, 725, 925, 25)
mymenu:menu("w","W Settings")
mymenu.w:header("ws","W Settings")
mymenu.w:boolean("wc", "Use [W] in combo", true)
mymenu.w:boolean("wh", "Use [W] in harass", true)
mymenu.w:slider("harassWmana", "If mana% >= X% [W] enemy champ", 30, 0, 100, 1)
mymenu.w:boolean("wlc", "Use [W] in laneclear", false)
mymenu.w:slider("lcWmana", "If mana% >= X% use [W] on creeps", 45, 0, 100, 1)
mymenu.w:slider("minCountW", "Cast [W] if creep count >= X", 3, 1, 5, 1)
mymenu.w:slider("setWrange", "Set distance when W fires in combo mode. Max range is 950. Press F6 to after set", 875, 725, 950, 25)
mymenu:menu("e","E Settings")
mymenu.e:header("es","E Settings")
mymenu.e:boolean("ec", "Use [E] in combo", true)
mymenu.e:boolean("eh", "Use [E] in harass", true)
mymenu.e:slider("harassEmana", "If mana% >= X% [E] enemy champ", 50, 0, 100, 1)
mymenu.e:boolean("elc", "Use [E] in lane clear", true)
mymenu.e:slider("lcEmana", "If mana% >= X% use [E] to lane clear", 30, 0, 100, 1)
mymenu:menu("r","R settings")
mymenu.r:boolean("rAllOut", "Use R in combo if death is imminent", true)
mymenu.r:slider("rAllOutHealth", "If health% < X% use [R] in combo", 20, 0, 39, 1)
mymenu:menu("smiteSet","Auto Smite settings")
mymenu.smiteSet:boolean("smiteDragon", "Use Auto Smite on dragon?", true)
mymenu.smiteSet:boolean("smiteHerald", "Use Auto Smite on Herald?", true)
mymenu.smiteSet:boolean("smiteBaron", "Use Auto Smite on Baron?", true)
mymenu:menu("csmiteSet", "Competitive Smite settings")
mymenu.csmiteSet:boolean("smiteRed", "Smite Red if enemy nearby?", true)
mymenu.csmiteSet:boolean("smiteCrab", "Smite Crab if enemy nearby?", true)
mymenu.csmiteSet:boolean("smiteBlue", "Smite Blue if enemy nearby?", true)

mymenu:header("version", "Version: " .. Version)
mymenu:header("developer", "Developer: Jonathan")
mymenu:header("credits", "Credits:")
mymenu:header("credits1", "Zen Community and Battery")


SpellQ = { collision = { minion = true, walls = true, terrain = true }, delay = 0.25, range = mymenu.q.setQrange:get(), width = 160 } 
SpellW = { delay = 0.25, radius = 250, range = mymenu.w.setWrange:get() }
SpellE = { range = 425 }
SpellR = { delay = 0.25, radius = 800, range = 1000 } 

DragonsGrudgeStacks = 0
smiteDamage = 0
smiteSlot = nil

function drawRanges()
	if player.dead then return end

	graphics.draw_circle(player, player.attackRange + player.boundingRadius, -1, 0xff730073)

	if mymenu.draw_settings.qRange:get() and player:spellSlot(0).state == 0 then
		graphics.draw_circle(player, SpellQ.range, -1, 0xff0000ff)
	end
	
	if mymenu.draw_settings.wRange:get() and player:spellSlot(1).state == 0 then
		graphics.draw_circle(player, SpellW.range, -1, 0xffff8c00)
	end

	if mymenu.draw_settings.eRange:get() and player:spellSlot(2).state == 0 then
		graphics.draw_circle(player, SpellE.range, -1, 0xff228b22)
	end

	if mymenu.draw_settings.rRange:get() and player:spellSlot(3).state == 0 then
		graphics.draw_circle(player, SpellR.range, -1, 0xffff0000)
	end 
end
cb.add(cb.draw, drawRanges)

function drawReload()
	if player.passiveCooldownEndTime > game.time then 
		graphics.draw_text_2D("RELOADING..", 20, player.barPos.x+10, player.barPos.y-24  , 0xFFFF0000)
	end
end
cb.add(cb.draw_hud, drawReload)

local f = function(attack)
	if attack.owner.isMe then
		if orb.core.mode() == OrbwalkingMode.Combo then
			for target in ts.get_targets() do
				if player:isInAutoAttackRange(target) and player:spellSlot(2).state == 0 then
					player:castSpell('pos', 2, game.mousePos)
				end
			end
		elseif orb.core.mode() == OrbwalkingMode.LaneClear then
			for minion in objManager.minions{ exclude_team = player.team, dist = 950, valid_target = true } do
				if not minion.isPlant and mymenu.e.elc:get() and  player.mana / player.maxMana * 100. >= mymenu.e.lcEmana:get() then
					if game.mousePos:isUnderEnemyTurret() then
						player:castSpell('pos', 2, player.pos:shorten(game.mousePos, 50))
					else
						player:castSpell('pos', 2, game.mousePos)
					end
				end
			end
		elseif orb.core.mode() == OrbwalkingMode.Mixed then
			for target in ts.get_targets() do
				if target:isValidTarget(1000, true, player.pos, false, false, true, false) then
					if player:isInAutoAttackRange(target) and player:spellSlot(2).state == 0 and mymenu.e.eh:get() then
						if player.mana / player.maxMana * 100. >= mymenu.e.harassEmana:get() then
							player:castSpell('pos', 2, game.mousePos)
						end
					end
				end
			end
		end
	end
end
cb.add(cb.auto_attack, f)

local function checkMode()
	if orb.core.mode() == OrbwalkingMode.Combo then
		Combo()
	elseif orb.core.mode() == OrbwalkingMode.Mixed then
    	Harass()
	elseif orb.core.mode() == OrbwalkingMode.LaneClear then
    	LaneClear()
	elseif orb.core.mode() == OrbwalkingMode.LastHit then
		LastHit()
	elseif orb.core.mode() == OrbwalkingMode.Flee then
		Flee()
	end
end
cb.add(cb.tick, checkMode)

function Combo()
	for target in ts.get_targets() do
		if target:dist() < SpellQ.range and player:spellSlot(0).state == 0 and mymenu.q.qc:get() then
			local seg = pred.linear.get_prediction(SpellQ, target)
			if seg then
				local result = pred.collision.get_prediction(SpellQ, seg, target)
				if result[1] and result[1].pos:dist() > seg.endPos:dist() then
					if player:spellSlot(0).state == 0 then
						player:castSpell('pos', 0, seg.endPos)	
					end 
				end
			end
		end
		if target:isValidTarget(1000, true, player.pos, false, false, true, false) then
			if target:dist() < SpellW.range and player:spellSlot(1).state == 0 then
				local seg = pred.circular.get_prediction(SpellW, target)
				if seg then
					player:castSpell('pos', 1, seg.endPos)
				end
			end
			if target:dist() < SpellQ.range and player:spellSlot(0).state == 0 and mymenu.q.qc:get() then
				local seg, seg2= pred.linear.get_prediction(SpellQ, target)
				if seg then
					player:castSpell('pos', 0, seg.endPos)
				end
				if seg2 and seg2.hitchance == Hitchance.Collision and #seg2.collisionObjects > 0 then
					local object = seg2.collisionObjects[1]
					if object.isMinion then
						player:castSpell('pos', 0, seg2.endPos) 
					end
				end	
			end
		end
		if mymenu.r.rAllOut:get() and player.health < (player.maxHealth * mymenu.r.rAllOutHealth:get() / 100) then
			if target:dist() < SpellR.range and player:spellSlot(3).state == 0 and not target.isInvulnerable then
				local seg = pred.linear.get_prediction(SpellR, target)
				if seg then
					player:castSpell('pos', 3, seg.endPos)
				end
			end
		end
	end
end

function Harass()
	for target in ts.get_targets() do
		if target:isValidTarget(1000, true, player.pos, false, false, true, false) then
			if target:dist() < 925 and player:spellSlot(1).state == 0 and mymenu.w.wh:get() then
				if player.mana / player.maxMana * 100. >= mymenu.w.harassWmana:get() then
					local seg, seg2= pred.linear.get_prediction(SpellQ, target)
					if seg then
						player:castSpell('pos', 0, seg.endPos)
					end
					if seg2 and seg2.hitchance == Hitchance.Collision and #seg2.collisionObjects > 0 then
						local object = seg2.collisionObjects[1]
						if object.isMinion then
							player:castSpell('pos', 0, seg2.endPos) 
						end
					end	
				end
			end
			if target:dist() < SpellQ.range and player:spellSlot(0).state == 0 and mymenu.q.qh:get() then
				if player.mana / player.maxMana * 100. >= mymenu.q.harassQmana:get() then
					local seg = pred.linear.get_prediction(SpellQ, target)
					if seg then
						player:castSpell('pos', 0, seg.endPos)
					end
				end
			end
		end
	end
end

local q1Dmg = (30 + (15 * player:spellSlot(0).level)) + (player.totalBonusAttackDamage * 0.80)

function LaneClear()
	local pointList2 = {}
	for minion in objManager.minions{ exclude_team = player.team, dist = 950, valid_target = true } do
		pointList2[#pointList2 + 1] = minion.pos
		local primary_output, secondary_output = pred.linear.get_prediction(SpellQ, minion)
		if not primary_output then
			if secondary_output.hitchance == Hitchance.Collision and #secondary_output.collisionObjects >= mymenu.q.minCountQ:get() then
				if player:spellSlot(0).state == 0 and mymenu.q.qlc:get() and player.mana / player.maxMana * 100. >= mymenu.q.lcQmana:get() then
					player:castSpell('pos', 0, secondary_output.endPos)	
				end
  			end
		end
	end
	if player:spellSlot(1).state == 0 and mymenu.w.wlc:get() and #pointList2 >= mymenu.w.minCountW:get() and player.mana / player.maxMana * 100. >= mymenu.w.lcWmana:get() then
		local enemyDist = getClosestEnemy()
		if enemyDist < 1300 then goto skip end
		local c = geometry.mec(pointList2)
		if c.radius <= 250 then
			player:castSpell("pos", 1, c.center)
		end
	end
	::skip::
	for minion in objManager.minions{ exclude_team = player.team, dist = 950, valid_target = true } do
		local thisDmg = (damage.autoattack(player, minion, false))*2 + getDamage(minion, q1Dmg) + 100
		if mymenu.q.qlc:get() and minion:totalHealth() > thisDmg and player:spellSlot(0).state == 0 then
			if player.mana / player.maxMana * 100. >= mymenu.q.lcQmana:get() then
				local seg = pred.linear.get_prediction(SpellQ, minion)
				if seg then
					player:castSpell('pos', 0, seg.endPos)
				end
			end
		end
	end
end

function LastHit()
end

function Flee()
end

function killSteal()
	if mymenu.setKS.qSteal:get() and player:spellSlot(0).state == 0 then
		for enemy in objManager.heroes{ team = TEAM_ENEMY, dist = 1000, valid_target = true, ignore_invisible = true } do
			if canExecute(enemy, 0) and not enemy.isInvulnerable and not enemy.willReviveOnDeath then
				local seg = pred.linear.get_prediction(SpellQ, enemy)
				if seg and (enemy.isSlowed or seg.endPos:isWall()) then
					player:castSpell('pos', 0, seg.endPos)
				end
     		end
		end
	end
	if mymenu.setKS.rSteal:get() and player:spellSlot(3).state == 0 then
		for enemy in objManager.heroes{ team = TEAM_ENEMY, dist = 1000, valid_target = true, ignore_invisible = true } do
			if canExecute(enemy, 3) and not enemy.isInvulnerable and not enemy.willReviveOnDeath then
				local seg = pred.linear.get_prediction(SpellR, enemy)
				if seg then
					player:castSpell('pos', 3, seg.endPos)
				end
			end
		end
	end
end
cb.add(cb.tick, killSteal)

function canExecute(obj, spellIndex)
	if spellIndex == 0 then
		local q1Dmg = (30 + (15 * player:spellSlot(0).level)) + (player.totalBonusAttackDamage * 0.80)
		local q2Dmg = (50 + (35 * player:spellSlot(0).level)) + ((10 + (30 * player:spellSlot(0).level))/100) * player.totalBonusAttackDamage
		local totalQdmg = q1Dmg + q2Dmg
		local actualDmg = getDamage(obj, totalQdmg)
		local enemyHealth = obj:totalHealth()
		if actualDmg > enemyHealth then return true else return false end
	elseif spellIndex == 3 then
		local rDmg =  (100 + (150 * player:spellSlot(3).level)) + (player.totalBonusAttackDamage * 1.50)
		local actualDmg = getDamage(obj, rDmg)
		local enemyHealth = obj:totalHealth()
		if actualDmg > enemyHealth then return true else return false end
	end
end

function getDamage(obj, spellDmg)
	if player.physicalLethality > 0 or player.percentArmorPenetration < 1.0 then
        if obj.armor < 0 then
            local dmgMulti = 2-(100/(100 - obj.armor))
			return dmgMulti * spellDmg
        end
 
        local newTargetArmor = obj.armor*player.percentArmorPenetration
        if newTargetArmor <= 0 then newTargetArmor = 0 end
        
        local lethality = player.physicalLethality*(0.6 + 0.4*(player.levelRef/18))
 
        local newerrrTargetArmor = newTargetArmor - lethality
        if newerrrTargetArmor <= 0 then newerrrTargetArmor = 0 end
 
        local dmgMulti = 100/(100 + newerrrTargetArmor)
		local damage = dmgMulti * spellDmg
	
        if obj.isDragon then
			local grudgeDmgRed = (DragonsGrudgeStacks*7)/100
			if grudgeDmgRed == 0 then return damage end
            local newDrgnDmg = damage * grudgeDmgRed
			return damage - newDrgnDmg
		end
		
		return damage
    end
    local dmgMulti = 100/(100 + obj.armor)
    if obj.armor < 0 then dmgMulti = 2-(100/(100 - obj.armor)) end
    local damage = dmgMulti * spellDmg
 
    if obj.isDragon then
		local grudgeDmgRed = (DragonsGrudgeStacks*7)/100
		if grudgeDmgRed == 0 then return damage end
		local newDrgnDmg = damage * grudgeDmgRed
        return damage - newDrgnDmg
	end
	return damage
end

function updateStackCount()
	DragonsGrudgeStacks = 0
	SpellQ.range = mymenu.q.setQrange:get()
	SpellW.range = mymenu.w.setWrange:get()
    for i = 0, player.buffManager.count - 1 do
        local buff = player.buffManager:get(i)
        if buff.valid then
            if buff.name:find("SRX_DragonBuff") then
                DragonsGrudgeStacks = DragonsGrudgeStacks + 1  
				if DragonsGrudgeStacks > 4 then
					DragonsGrudgeStacks = 4
				end
        	end
		end
	end
	smiteDamage = math.max(20*player.levelRef+370,30*player.levelRef+330,40*player.levelRef+240,50*player.levelRef+100) or 0 --nebelwolfi
end
cb.add(cb.slow_tick, updateStackCount)

function smiteObjectives()
	for minion in objManager.minions{ exclude_team = player.team, dist = 500, valid_target = true } do
		if minion.charName:find("SRU_Dragon") and mymenu.smiteSet.smiteDragon:get() then
			if minion:totalHealth() < smiteDamage and smiteSlot and player:spellSlot(smiteSlot).state == 0 then
					player:castSpell("obj", smiteSlot, minion)
			end
		elseif minion.charName == "SRU_RiftHerald" and mymenu.smiteSet.smiteHerald:get() then
			if minion:totalHealth() < smiteDamage and smiteSlot and player:spellSlot(smiteSlot).state == 0 then
					player:castSpell("obj", smiteSlot, minion)
			end
		elseif minion.charName == "SRU_Baron" and mymenu.smiteSet.smiteBaron:get() then
			if minion:totalHealth() < smiteDamage and smiteSlot and player:spellSlot(smiteSlot).state == 0 then
					player:castSpell("obj", smiteSlot, minion)
			end
		end
	end
end
cb.add(cb.tick, smiteObjectives)

function competitiveSmite()
	local enemyDist = getClosestEnemy()
	if enemyDist > 1300 then return end
	for minion in objManager.minions{ exclude_team = player.team, dist = 500, valid_target = true } do
		if minion.charName:find("SRU_Red") and mymenu.csmiteSet.smiteRed:get() then
			if minion:totalHealth() < smiteDamage and smiteSlot and player:spellSlot(smiteSlot).state == 0 then
				if enemyDist < 950 and minion:dist() < 500 then
					player:castSpell("obj", smiteSlot, minion)
				end
			end
		elseif minion.charName == "Sru_Crab" and mymenu.csmiteSet.smiteCrab:get() then
			if minion:totalHealth() < smiteDamage and smiteSlot and player:spellSlot(smiteSlot).state == 0 then
				if enemyDist < 950 and minion:dist() < 500 then
					player:castSpell("obj", smiteSlot, minion)
				end
			end
		elseif minion.charName == "SRU_Blue" and mymenu.csmiteSet.smiteBlue:get() then
			if minion:totalHealth() < smiteDamage and smiteSlot and player:spellSlot(smiteSlot).state == 0 then
				if enemyDist < 950 and minion:dist() < 500 then
					player:castSpell("obj", smiteSlot, minion)
				end
			end
		end
	end
end
cb.add(cb.tick, competitiveSmite)

function getClosestEnemy()
	local closestEnemy
	local closestDist = 10000

	for champ in objManager.iheroes do
		if champ.valid and champ.isEnemy and not champ.isDead then
			local enemy = champ
			local distance = champ:dist()
			if distance < closestDist then
				closestEnemy = enemy
				closestDist = distance
			end
		end
	end
	return closestDist
end

local onLoad = function()
	print("Jonathan's Graves Loaded!")
	for slot = 0, 6 do
		if player:spellSlot(slot).name:find("Smite") then
			smiteSlot = slot
		end
	end
	chat.print("Jonathan's Graves Loaded!")
end
cb.add(cb.load, onLoad)

